require('lang.load')

import('model.events.gui.GuiClickEvent')
import('model.events.gui.GuiElementChangedEvent')
import('model.events.gui.GuiLocationChangedEvent')
import('model.events.CursorStackChanged')
import('model.events.InventoryChanged')
import('model.Interface')
import('model.Cursor')
import('model.Inventory')
import('model.InventorySyncScheduler')

ToolbarsMod = { name = "toolbars-mod" }

---@param eventData EventData
script.on_event(ToolbarsMod.name .. "_create-toolbar", function(eventData)
    --Interface:getInstanceFor(eventData.player_index):deleteAll()
    Interface:getInstanceFor(eventData.player_index):createToolbar()
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_click, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiClick(GuiClickEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_elem_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiChange(GuiElementChangedEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_location_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiChange(GuiLocationChangedEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_cursor_stack_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handle(CursorStackChanged:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_main_inventory_changed, function(eventData)
    InventorySyncScheduler:scheduleFor(eventData.player_index)
end)

---@param eventData EventData
script.on_event(defines.events.on_player_trash_inventory_changed, function(eventData)
    InventorySyncScheduler:scheduleFor(eventData.player_index)
end)

-- seems that defines.events.on_player_changed_surface is triggered before new inventory is available
---@param eventData EventData
script.on_event(defines.events.on_player_toggled_map_editor, function(eventData)
    InventorySyncScheduler:scheduleFor(eventData.player_index)
end)

script.on_nth_tick(5, function(eventData)
    InventorySyncScheduler:run()
end)

remote.add_interface(ToolbarsMod.name, {
    inventoryChanged = function(player_index)
        for _ = 0, 0 do
            Interface:getInstanceFor(player_index):handle(InventoryChanged:new())
        end
    end,
    adjustToolbarsSize = function(player_index)
        for _ = 0, 0 do
            Interface:getInstanceFor(player_index):adjustToolbarsSize()
        end
    end
})
