import('model.Component')

---@class Screen : Component
Screen = Component:extendAs("model.Screen")

---@param parent Component
---@param root LuaGuiElement
function Screen:new(parent, root)
    local instance = Screen:super(Component:new(parent, root))
    instance:loadChildren()
    return instance
end

function Screen:childrenClasses()
    return { Toolbar }
end

---@public
---@return Toolbar
function Screen:createToolbar()
    return Toolbar:create(self)
end

---@private
---@param element LuaGuiElement
---@return boolean
function Screen:isRepresentedBy(element)
    return element.gui.screen == element
end
