import('model.Component')
import('model.toolbar.content.sections.Sections')
import('model.toolbar.content.AddSection')

---@class ToolbarContent : Component
ToolbarContent = Slot:extendAs("model.toolbar.content.Content")

function ToolbarContent:create(parent)
    local instance = Component.create(self, parent, {
        type = "scroll-pane",
        direction = "vertical",
        vertical_scroll_policy = "auto",
        style = "toolbar_content" })
    Sections:create(instance)
    AddSection:create(instance)
    return instance
end

---@public
---@return ToolbarContent
---@param root LuaGuiElement
function ToolbarContent:new(parent, root)
    local instance = ToolbarContent:super(Component:new(parent, root))
    instance:loadChildren()
    return instance
end

function ToolbarContent:childrenClasses()
    return { Sections, AddSection }
end

---@public
---@return Sections
function ToolbarContent:sections()
    return self:childOfType(Sections)
end
