import('model.toolbar.content.sections.section.content.table.Slot')

---@private
---@class Tool : Slot
Tool = Slot:extendAs("model.toolbar.content.sections.section.content.table.slots.Tool")

function Tool:create(parent, itemName)
    return Component.create(self, parent, {
        type = "sprite-button",
        elem_tooltip = { type = "item", name = itemName },
        sprite = "item/" .. assert(itemName),
        style = "toolbar_content_sections_section_content_table_row_slot",
        mouse_button_filter = { "left", "middle" } })
end

function Tool:new(parent, root)
    return Tool:super(Slot:new(parent, root))
end

function Tool:handleGuiClick(click)
    if click:isLeft() then
        self:cursor():pickTool(self:itemName())
        self:rememberPick()
    elseif click:isMiddle() then
        self:clear()
    end
end

function Tool:itemName()
    return self:root().elem_tooltip.name
end
